import numpy as np


class Point:

    def __init__(self, X):

        self.X = X

    @staticmethod
    def from_components(x, y):

        return Point(np.array([x, y, 1]))

    @property
    def x(self):

        return self.X[0] / self.X[-1]

    @property
    def y(self):

        return self.X[1] / self.X[-1]

    @property
    def euk(self):

        return self.X[:-1] / self.X[-1]

    def transform(self, M):

        return Point(self.X.dot(M.T))

    def __repr__(self):

        return "Point(x = %6.3f, y = %6.3f)" % (self.x, self.y)
