from pydantic import BaseModel


class Detection(BaseModel):

    category_name: str
    model_name: str
    confidence: float
    x: float
    y: float
    width: float
    height: float

    @property
    def cx(self) -> float:
        return self.x + self.width / 2

    @property
    def cy(self) -> float:
        return self.y + self.height / 2

    def __str__(self):
        return f'x:{int(self.x)} y: {int(self.y)}, w: {int(self.width)} h: {int(self.height)} cat: {self.category_name} conf: {self.confidence:.2f}'
