from pydantic import BaseModel
from typing import Optional
from ..world.point import Point
from .detection import Detection


class Size(BaseModel):

    width: int
    height: int


class Image(BaseModel):

    id: str
    time: float
    mac: str
    size: Size
    detections: Optional[list[Detection]]
    marker_points: Optional[dict[str, Point]]
