from pydantic import BaseModel
from typing import Dict, Tuple
import numpy as np


class Marker(BaseModel):

    height: float
    points: Dict[str, Tuple[float, float]]

    @staticmethod
    def four_points(space, x_shift, height):

        points = {
            'marker_mitte': (x_shift, 0),
            'marker_hinten_links': (x_shift - np.sqrt(3 / 4) * space, space / 2),
            'marker_hinten_rechts': (x_shift - np.sqrt(3 / 4) * space, -space / 2),
            'marker_vorne': (x_shift + space, 0),
        }
        return Marker(height=height, points=points)
