from rosys.world.image import Image
from pydantic import BaseModel
from datetime import datetime


class Upload(BaseModel):
    minimal_minutes_between_uploads = 5
    last_upload: datetime = datetime.fromtimestamp(0)
    queue: dict[str, Image] = {}  # NOTE: dictionary with image ids as key to ensure uniqueness

    def mark(self, image: Image):
        '''Mark an image for upload. May still not get uploaded because minimal_minutes_between_uploads has not elapsed.'''
        self.queue[image.id] = image
